/********************************************************************/
/*      Main.h                                                      */
/*          Library Header Include and                              */
/*         Global Symbol External Declaration                       */
/*                                                                  */
/*              Copyright (C) 1999-2001 NINTENDO Co.,Ltd.           */
/********************************************************************/
#ifndef	__MAIN_H__
#define	__MAIN_H__

//#define	__SRAM_FAST_SELECT   // When using AgbSramFast.h, make this definition
				// effective, When using AgbSram.h
							// make ineffective.

#ifdef	__SRAM_FAST_SELECT
#include <AgbSramFast.h>
#else
#include <AgbSram.h>
#endif
#include <AgbFlash.h>
#include <AgbEeprom.h>
#include <AgbDacs.h>

#define	__SOUND_ON				// When sound is used in the program, 
								// validate this definition.
#ifdef	__SOUND_ON
#include "sound/m4aLib.h"
#endif

#define	EEPROM_KBIT_SIZE	4	//  When 4Kbit EEPROM is used, set "4" here, 
								// and when 64Kbit  
								// EEPROM is used, set "64" here. 


#define	COMMON_BUFFER		0x02010000


extern void (*IntrTable[14])();
extern void (*ActiveProcess)();
extern void ReturnMain();

#endif	/* __MAIN_H__ */
